﻿; 작성자 : DDART, 배포장소 : DDART AUTOMATION (https://auto.ddart.net)
#SingleInstance Force
global _app := new CSetupV3("autocoder_setup", "1.09")
return
SetWorkingDir %A_ScriptDir%
FileEncoding, UTF-8
class CSetupV3
{
	__New(name, version)
	{
		CheckUpdate(name, version)
		w := 500, h := 300
		Gui, +hWndhWnd -Resize -MaximizeBox -MinimizeBox
		this.hWnd := hWnd
		static wb := 0
		Gui, Add, ActiveX, x0 y0 w%w% h%h% vwb, about:<!DOCTYPE html><meta http-equiv='X-UA-Compatible' content='IE=Edge'>
		this.wb := wb
		this.InitIcon(12)
		this.InitBrowser()
		this.InitVCRuntime()
		this.InitAutohotkey()
		this.InitWebview()
		this.InitAutocoder()
		this.InitExec()
		OnMessage(CWINUSER.WM_SYSCOMMAND, this.OnSysCommand.Bind(this))
		Gui, Show, w%w% h%h%, 상품권 자동입력기 버전3 실행환경 설정 v%version%
		fn := this.UpdateVersionInfo.Bind(this)
		SetTimer, %fn%, -10
	}
	InitAutocoder()
	{
		version := ""
		if (FileExist("autocoder.ahk"))
		{
			version := "알수없음"
			FileReadLine, appinfo, autocoder.ahk, 2
			if (RegExMatch(appinfo, "O)자동입력기 버전 ([\d\.]+)", matches))
			{
				version := matches[1]
			}
		}
		this.bAutocoder := this.ie.SetCurrentVersion("AUTOCODER", version)
	}
	InitVCRuntime()
	{
		arch := A_PtrSize == 8 ? "x64" : "x86"
		RegRead, installed, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\VisualStudio\14.0\VC\Runtimes\%arch%, Installed
		this.bVcRuntime := installed
		if (installed)
		{
			RegRead, ver_vcruntime, HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\VisualStudio\14.0\VC\Runtimes\%arch%, Version
			ver_vcruntime := StrReplace(ver_vcruntime, "v")
			this.ie.SetCurrentVersion("VCRUNTIME", ver_vcruntime)
			this.ie.SetLatestVersion("VCRUNTIME", ver_vcruntime)
		}
		else
		{
			this.ie.SetLatestVersion("VCRUNTIME", "14.38.33130.00")
		}
	}
	InitAutohotkey()
	{
		RegRead, ver_autohotkey, HKEY_LOCAL_MACHINE\SOFTWARE\AutoHotkey, Version
		version := ver_autohotkey >= 2.0 ? ver_autohotkey : ""
		this.bAutohokey := this.ie.SetCurrentVersion("AUTOHOTKEY", version)
	}
	InitBrowser()
	{
		this.wb.document.open()
		this.wb.document.write(GetHtml())
		this.wb.document.close()		
		Loop 20
		{
			if (this.wb.document.readyState = "complete")
				break
			Sleep, 100
		}
		this.ie := this.wb.document.parentWindow
		this.ie.AhkHandler := this.JSHandler.Bind(this)
	}
	InitExec()
	{
		this.ie.SetProperty("EXEC_AUTOCODER", "disabled", !this.bAutohokey || !this.bWebView || !this.bAutocoder || !this.bVcRuntime)
	}
	InitIcon(idx)
	{
		hModule := DllCall("LoadLibrary", "str", "shell32.dll", "ptr")
		hIcon := DllCall("LoadImage", "ptr", hModule, "Uint", idx, "Uint", IMAGE_ICON := 1, "int", 0, "int", 0, "Uint", LR_SHARED :=0x00008000 | LR_DEFAULTSIZE := 0x00000040, "ptr")
		DllCall("SendMessage", "ptr", this.hWnd, "uint", WM_SETICON := 0x0080, "uptr", 0, "ptr", hIcon)
	}
	InitWebview()
	{
		reg_webview_path := "HKEY_LOCAL_MACHINE\SOFTWARE\" ((A_PtrSize = 8) ? "WOW6432Node\" : "") "Microsoft\EdgeUpdate\Clients\{F3017226-FE2A-4295-8BDF-00C3A9A7E4C5}"
		version := ""
		RegRead, version , %reg_webview_path%, pv
		if (!version)
		{
			reg_webview_path := "HKEY_CURRENT_USER\Software\Microsoft\EdgeUpdate\Clients\{F3017226-FE2A-4295-8BDF-00C3A9A7E4C5}"
			RegRead, version , %reg_webview_path%, pv
		}
		this.bWebView := this.ie.SetCurrentVersion("WEBVIEW", version)
	}
	Install(name, url, filename)
	{
		MsgBox, 4, %name% 설치, %url%`r`n`r`n에서 %name%를 다운받고 설치하려고 합니다. 계속 진행하시겠습니까?
		IfMsgBox, Yes
		{
			if(HttpGet(url, filename))
			{
				ext := SubStr(filename, -2)
				if (ext == "exe")
				{
					RunWait, %filename%
				}
				else if (ext == "zip")
				{
					obj := ComObjCreate("Shell.Application")
					obj.Namespace(A_ScriptDir).CopyHere(obj.Namespace(A_ScriptDir "\" filename).items, 4|16)
					ObjRelease(obj)
				}
				Sleep, 500
				Loop, 10
				{
					try
					{
						FileDelete, %filename%
						if (!FileExist(filename))
						{
							break
						}
					}
					catch e
					{
						Sleep, 500
					}
				}
				return true
			}
		}
		return false
	}
	UpdateVersionInfo()
	{
		res := HttpGet("https://auto.ddart.net/download/autocoder/version")
		if (RegExMatch(res, "O)""version"":""([\d\.]+)""", matches))
		{
			this.ie.SetLatestVersion("AUTOCODER", matches[1])
		}
/*		
		res := HttpGet("https://api.github.com/repos/AutoHotkey/AutoHotkey/releases/latest")
		if (RegExMatch(res, "O)""name""[:\s]+""v([\d\.]+)""", matches))
		{
			this.ie.SetLatestVersion("AUTOHOTKEY", matches[1])
		}
*/		
		res := HttpGet("https://www.autohotkey.com/download")
		;<span class="curver">2.0.11</span>
		if (RegExMatch(res, "O)""curver""\s*\>\s*(2[\d\.]+)", matches))
		{
			this.ie.SetLatestVersion("AUTOHOTKEY", matches[1])
		}
		if (A_OSVersion == "WIN_7")
		{
			this.ie.SetLatestVersion("WEBVIEW", "109.0.1518.140")
		}
		else
		{
			res := HttpGet("https://developer.microsoft.com/ko-kr/microsoft-edge/webview2")
			if (RegExMatch(res, "O) id=""version"".+<span>([\d\.]+)<", matches))
			{
				this.ie.SetLatestVersion("WEBVIEW", matches[1])
			}
		}
	}
	JSHandler(cmd, id)
	{
		if (cmd == "link")
		{
			if (id == "LINK_AUTOHOTKEY")
			{
				Run, https://www.autohotkey.com
			}
			else if (id == "LINK_VCRUNTIME")
			{
				Run, https://learn.microsoft.com/ko-kr/cpp/windows/latest-supported-vc-redist
			}
			else if (id == "LINK_WEBVIEW")
			{
				Run, https://developer.microsoft.com/ko-kr/microsoft-edge/webview2/
			}
			else if (id == "LINK_AUTOCODER")
			{
				Run, https://auto.ddart.net
			}
		}
		else if (cmd == "install")
		{
			if (id == "INST_AUTOHOTKEY")
			{
				if (this.Install("오토핫키 V2", "https://www.autohotkey.com/download/ahk-v2.exe", "Autohotkey2Setup.exe"))
				{
					this.InitAutohotkey()
					this.InitExec()
				}
			}
			else if (id == "INST_VCRUNTIME")
			{
				if (this.Install("VC++ 2015 런타임", A_PtrSize == 8 ? "https://aka.ms/vs/17/release/vc_redist.x64.exe" : "https://aka.ms/vs/17/release/vc_redist.x86.exe", "vc_redist.exe"))
				{
					this.InitVCRuntime()
					this.InitExec()
				}
			}
			else if (id == "INST_WEBVIEW")
			{
				if (this.Install("웹뷰2", "https://go.microsoft.com/fwlink/p/?LinkId=2124703", "MicrosoftEdgeWebview2Setup.exe"))
				{
					this.InitWebview()
					this.InitExec()
				}
			}
			else if (id == "INST_AUTOCODER")
			{
				if (this.Install("자동입력기", "https://auto.ddart.net/download/autocoder/current", "autocoder_current.zip"))
				{
					this.InitAutocoder()
					this.InitExec()
				}
			}
		}
		else if (cmd == "exec")
		{
			if (id == "EXEC_AUTOCODER")
			{
				Run, autocoder.ahk
			}
		}
	}
	OnSysCommand(wParam, lParam, nMsg, hWnd)
	{
		if (wParam == CWINUSER.SC_CLOSE)
		{
			if (this.cmd_exit)
			{
				Run, % this.cmd_exit
			}
			ExitApp
		}
	}
}
class CWINUSER
{
	static WM_SYSCOMMAND := 0x0112
	static SC_CLOSE := 0xF060
}
CheckUpdate(name, version)
{
	timestamp := A_Now
	timestamp -= 19700101000000, seconds
	RegRead, LastUpdate , HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate
	if (LastUpdate && timestamp - LastUpdate < 12 * 60 * 60)
		return
	if (!RegExMatch(HttpGet("https://auto.ddart.net/download/" name "/version"), "O)""version"":""([^""]+)", matches))
		return
	RegWrite, REG_DWORD, HKEY_CURRENT_USER\Software\DDART\%name%, LastUpdate, %timestamp%
	version_new := matches[1]
	if (version_new <= version)
		return
	MsgBox, 4, 업데이트확인, 새로운 버전(%version_new%)이 있습니다. 업그레이드 하시겠습니까?
	IfMsgBox, No
		return
	zip := A_ScriptDir "\" name ".zip"
	if (!HttpGet("https://auto.ddart.net/download/" name "/" version_new, zip))
		return MsgBox, %zip% 다운로드 실패
	backup_dir := "backup_versions"
	if (!FileExist(backup_dir))
		FileCreateDir, %backup_dir%
	src := A_ScriptDir "\" name ".ahk"
	dst := A_ScriptDir "\" backup_dir "\" name "_v" version ".ahk"
	FileMove, %src%, %dst%, true
	obj := ComObjCreate("Shell.Application")
	obj.Namespace(A_ScriptDir).CopyHere(obj.Namespace(zip).items, 4|16)
	ObjRelease(obj)
	Run, %src%
	ExitApp
}
HttpGet(url, filename := "")
{
	hRequest := 0, hConnection := 0, hSession := 0, fp := 0, responseText := ""
	try
	{
		if (!RegExMatch(url, "O)http(s?)://([^/]+)(.+)", matches))
			throw url "은 잘못된 주소"
		if (!hSession := DllCall("winhttp\WinHttpOpen","WStr", "HttpGet" ,"Uint", 0, "Ptr" , 0, "Ptr", 0, "Uint", 0))
			throw "WinHttpOpen error : " A_LastError
		if (!hConnection := DllCall("winhttp\WinHttpConnect", "Ptr", hSession, "WStr", matches[2], "UShort", 0, "Uint", 0))
			throw "WinHttpConnect error : " A_LastError
		if (!hRequest := DllCall("winhttp\WinHttpOpenRequest", "Ptr", hConnection, "WStr", "GET", "WStr", matches[3], "Ptr", 0, "Ptr", 0, "Ptr", 0, "Uint", dwFlags := matches[1] == "s" ? WINHTTP_FLAG_SECURE := 0x00800000 : 0))
			throw "WinHttpOpenRequest error : " A_LastError
		if (!DllCall("winhttp\WinHttpSetOption", "Ptr", hRequest, "UInt", WINHTTP_OPTION_CLIENT_CERT_CONTEXT := 47, "Ptr", 0, "UInt", 0))
			throw "WinHttpSetOption error : " A_LastError
		if (!DllCall("winhttp\WinHttpSendRequest", "Ptr", hRequest, "Ptr", 0, "UInt", 0, "Ptr", 0, "UInt", 0, "UInt", 0, "Ptr", 0))
			throw "WinHttpSendRequest error : " A_LastError
		if (!DllCall("winhttp\WinHttpReceiveResponse", "Ptr", hRequest, "Ptr", 0))
			throw "WinHttpReceiveResponse error : " A_LastError
		if (filename)
			fp := FileOpen(filename, "w", "UTF-8-RAW")
		while(DllCall("winhttp\WinHttpQueryDataAvailable", "Ptr", hRequest, "UInt*", dwBytes := 0) && dwBytes)
		{
			VarSetCapacity(buf, dwBytes, 0)
			if (DllCall("winhttp\WinHttpReadData", "ptr", hRequest, "ptr", &buf, "uint", dwBytes, "uint*", 0))
			{
				if (fp)
					fp.RawWrite(&buf, dwBytes)
				else
					responseText .= StrGet(&buf, dwBytes, "UTF-8")
			}
		}
		if (fp)
		{
			length := fp.Length()
			fp.Close()
			if (!length)
				FileDelete, %filename% 
		}
	}
	catch e
		MsgBox, %e%
	for i, handle in [hRequest, hConnection, hSession]
		if (handle)
			DllCall("winhttp\WinHttpCloseHandle", "ptr", handle)
	if (filename)
		return FileExist(filename)
	else
		return responseText
}
GetHtml()
{
	html = 
(
<html lang="ko">
<head>
<meta charset="utf-8">
<style>
html{width:100`%;height:100`%; font-size :1em}
body {font-family : 돋움; margin:0;padding:0;overflow: hidden;font-size: 0.75rem; background-color:#F0F0F0;width:100`%;height:100`%;}
td {font-size : 0.75rem}
.header
{
	background-color: white;
	height : 50px;
}
.item_header
{
	text-align: center;
	background-color : #F0F0F0;
	height : 25px;
	border-top : 1px solid #C0C0C0;
}
.bottom
{
	height : 50px;
}
button
{
	border-radius:  4px;
	font-family : 돋움;
	font-size : 9pt;
	height : 25px;
	color : #1A73E8;
	background-color : white;
	border : 1px solid #DADCE0;
	cursor : pointer;
}
span.link
{
	margin-left : 10px;
	color : #1A73E8;
	cursor : pointer;
}
button:disabled
{
	background-color:#F0F0F0;
	color : #A0A0A0;
	cursor : default;
}
table.setup
{
	background-color : white;
	border-spacing : 0px;
	border-collapse: collapse;	
}
table.setup > tbody > tr
{
	border-bottom : 1px solid #C0C0C0;
}
table.setup  > tbody > tr > td:nth-child(2), td:nth-child(3),  td:nth-child(4) 
{
	text-align : center;
	width : 90px;
}
</style>
<script>
window.onload = OnLoad;
function OnLoad()
{
	["link", "install", "exec"].forEach(AddAhkListener);
}
function SetProperty(id, prop, value)
{
	const elm = document.getElementById(id);
	if (elm)
	{
		elm[prop] = value;
	}
}
function GetProperty(id, prop)
{
	const elm = document.getElementById(id);
	if (elm)
	{
		return elm[prop];
	}
	return "";
}
function SetCurrentVersion(id, version)
{
	SetProperty("VER_" + id, "innerText", version.length != 0 ? version : "설치안됨");
	sText = UpdateInstallButton(id);
	if (id == "WEBVIEW")
	{
		return sText != "설치안됨"
	}
	return  sText == "O K";
}
function SetLatestVersion(id, version)
{
	SetProperty("VER_" + id + "_LATEST", "innerText", version);
	UpdateInstallButton(id);
}
function VersionCompare(a, b)
{
	const va = a.split(".");
	const vb = b.split(".");
	for (let i = 0; i < va.length; i++)
	{
		if (i < vb.length)
		{
			const na = new Number(va[i]);
			const nb = new Number(vb[i]);
			if (na > nb)
			{
				return 1;
			}
			else if (na < nb)
			{
				return -1;
			}
		}
		else
		{
			return 1;
		}
	}
	if (vb.length > va.length)
	{
		return -1;
	}
	return 0;
}
function UpdateInstallButton(id)
{
	const current_ver = GetProperty("VER_" + id, "innerText");
	const latest_ver = GetProperty("VER_" + id + "_LATEST", "innerText");
	let bDisable = false;
	let sText = "설치";
	if (current_ver == "설치안됨")
	{
	}
	else if (VersionCompare(latest_ver, current_ver) > 0)
	{
		sText = "업데이트";
	}
	else
	{
		bDisable = true;
		sText = "O K";
	}
	SetProperty("INST_" + id, "disabled", bDisable);
	SetProperty("INST_" + id, "innerText", sText);
	return sText;
}
function AddAhkListener(clsname)
{
	const elms = document.getElementsByClassName(clsname);
	for (let i = 0; i < elms.length; i++)
	{
		elms[i].addEventListener("click", OnClick);
	}
}
function OnClick(e)
{
	if (AhkHandler)
	{
		AhkHandler(e.srcElement.className, e.srcElement.id);
	}
}
</script>
<body>
<table width=100`% height=100`% cellspacing=0>
<tr class=header>
  <td align=center> 
	자동입력기 버전3을 실행하려면 아래 4가지를 모두 설치해주세요
  </td>
</tr>
<tr class=body>
  <td>
    <table width=100`% height=100`% class=setup>
	  <tr class=item_header>
	    <td> 항목  </td>
	    <td> 현재버전 </td>
	    <td> 최신버전 </td>
	    <td> 설치 </td>
      </tr>
	  <tr>
	    <td><span id=LINK_AUTOHOTKEY class=link>오토핫키 V2</span></td>
	    <td id=VER_AUTOHOTKEY></td>
	    <td id=VER_AUTOHOTKEY_LATEST></td>
	    <td><button id=INST_AUTOHOTKEY class=install>설 치</button></td>
      </tr>		
	  <tr>
	    <td><span id=LINK_VCRUNTIME class=link>Microsoft VC++ 2015 런타임</span></td>
	    <td id=VER_VCRUNTIME></td>
	    <td id=VER_VCRUNTIME_LATEST></td>
	    <td><button id=INST_VCRUNTIME class=install>설 치</button></td>
      </tr>		
	  <tr>
	    <td><span id=LINK_WEBVIEW class=link>Microsoft 웹뷰2 런타임</span></td>
	    <td id=VER_WEBVIEW></td>
	    <td id=VER_WEBVIEW_LATEST></td>
	    <td><button id=INST_WEBVIEW  class=install>설 치</button></td>
      </tr>		
	  <tr>
	    <td><span id=LINK_AUTOCODER class=link>자동입력기 버전3</span>	</td>
	    <td id=VER_AUTOCODER></td>
	    <td id=VER_AUTOCODER_LATEST></td>
	    <td><button id=INST_AUTOCODER  class=install>설 치</button></td>
      </tr>		
	</table>
  </td>
</tr>
<tr class=bottom>
  <td align=center>
	<button id=EXEC_AUTOCODER disabled class=exec>자동입력기 버전3 실행</button>
  </td>
</tr>
</table>
</body>
</html>
)
	return html
}